#version 150

vec4 linear_fog(vec4 inColor, float vertexDistance, float fogStart, float fogEnd, vec4 fogColor) {
    if (vertexDistance <= fogStart) {return inColor;}

    float fogValue = vertexDistance < fogEnd ? smoothstep(fogStart, fogEnd, vertexDistance) : 1.0;
    float fogRedValue = ceil(fogColor.r * 255);
    float fogGreenValue = ceil(fogColor.g * 255);
    float fogBlueValue = ceil(fogColor.b * 255);

    if (fogRedValue == 153 && fogGreenValue == 26 && fogBlueValue == 0) {return vec4(mix(inColor.rgb, fogColor.rgb, fogValue * fogColor.a / 2.5), inColor.a);}
	// The top line affects Lava Fog

    if (fogRedValue == 159 && fogGreenValue == 188 && fogBlueValue == 201) {return vec4(mix(inColor.rgb, fogColor.rgb, fogValue * fogColor.a / 2.5), inColor.a);}
	// The top line affects Powder Snow Fog

    if (fogRedValue == 0 && fogGreenValue == 0 && fogBlueValue == 0) {return vec4(mix(inColor.rgb, fogColor.rgb, fogValue * fogColor.a / 2.5), inColor.a);}
	// The top line affects Blindness/Darkness Fogs

    if (fogRedValue == 21 && fogGreenValue == 17 && fogBlueValue == 21) {return vec4(mix(inColor.rgb, fogColor.rgb, fogValue * fogColor.a / 2.5), inColor.a);}
	// The top line affects Ender Dragon Fog

    else {return vec4(mix(inColor.rgb, fogColor.rgb, fogValue * fogColor.a), inColor.a);}

}

float linear_fog_fade(float vertexDistance, float fogStart, float fogEnd) {
    if (vertexDistance <= fogStart) {return 1.0;}
    else if (vertexDistance >= fogEnd) {return 0.0;}
    return smoothstep(fogEnd, fogStart, vertexDistance);
}

float fog_distance(mat4 modelViewMat, vec3 pos, int shape) {
    if (shape == 0) {return length((modelViewMat * vec4(pos, 1.0)).xyz);}
    else {
        float distXZ = length((modelViewMat * vec4(pos.x, 0.0, pos.z, 1.0)).xyz);
        float distY = length((modelViewMat * vec4(0.0, pos.y, 0.0, 1.0)).xyz);
        return max(distXZ, distY);
    }
}
